/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 3200; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 2.241682310460726e-06,2.1610760320133173e-06,2.163979363291479e-06,2.235375668956508e-06 };
    static double noise_model_B[] = { 3.561969723654716e-05,5.649330428456946e-05,5.553419236135312e-05,4.0873476346207535e-05 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { -4.670664998155088e-12,-5.575497759335336e-12,-5.6906270128509635e-12,-4.7358597891813264e-12 };
    static double noise_model_D[] = { 6.526848481048227e-06,3.7793553916117695e-06,4.091294821894064e-06,6.693505416872433e-06 };
    double digital_gain = (sens / 400.0) < 1.0 ? 1.0 : (sens / 400.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
