/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 3200; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 4.153545418146599e-06,4.084292364191258e-06,4.091144007111205e-06,4.15443205454418e-06 };
    static double noise_model_B[] = { 3.377496698005724e-05,6.582379466898263e-05,6.460285506579965e-05,4.084449380831925e-05 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { -9.838245405250235e-12,-1.1757191466059413e-11,-1.1934490762722898e-11,-9.601745796833285e-12 };
    static double noise_model_D[] = { 6.412951941815763e-06,-1.2855702408988797e-06,-1.0304806392080535e-06,5.716569679123424e-06 };
    double digital_gain = (sens / 400.0) < 1.0 ? 1.0 : (sens / 400.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
